LeetCode45 Jump Game II

题目:

Given an array of non-negative integers, you are initially positioned at the first index of the array.

Each element in the array represents your maximum jump length at that position.

Your goal is to reach the last index in the minimum number of jumps.

For example:
Given array A = [2,3,1,1,4]

The minimum number of jumps to reach the last index is 2. (Jump 1 step from index 0 to 1, then 3 steps to the last index.)

Note:
You can assume that you can always reach the last index. (Hard)

分析:

第一眼看完题目感觉用动态规划肯定能解,但是感觉就是有很多重复计算在里面...因为题目只问了个最少步数。

果然写出来之后华丽超时,但是代码还是记录一下吧

 1 class Solution {
 2 public:
 3     int jump(vector<int>& nums) {
 4         int dp[nums.size()];
 5         for (int i = 0; i < nums.size(); ++i) {
 6             dp[i] = 0x7FFFFFFF;
 7         }
 8         dp[0] = 0;
 9         for (int i = 1; i < nums.size(); ++i) {
10             for (int j = 0; j < i; ++j) {
11                 if (j + nums[j] >= i) {
12                     dp[i] = min(dp[i], dp[j] + 1);
13                 }
14             }
15         }
16         return dp[nums.size() - 1];
17     }
18 };

优化考虑类似BFS的想法,维护一个步数的范围和一个能走到的最远距离。

算法就是遍历一遍数组,到每个位置的时候,更新他能到达的最远距离end,如果一旦超过nums.size() - 1,就返回step + 1;

curEnd维护以当前步数能到达的最远范围,所以当i > curEnd时,step++,并且将curEnd更新为end。

代码:

 1 class Solution {
 2 public:
 3     int jump(vector<int>& nums) {
 4         if (nums.size() == 1) {
 5             return 0;
 6         }
 7         int step = 0, end = 0, curEnd = 0;
 8         for (int i = 0; i < nums.size(); ++i) {
 9             if (i > curEnd) {
10                 step++;
11                 curEnd = end;
12             }
13             end = max(end, nums[i] + i);
14             if (end >= nums.size() - 1) {
15                 return step + 1;
16             }
17         }
18         return -1;
19     }
20 };
 
原文地址:https://www.cnblogs.com/wangxiaobao/p/5835856.html